﻿// $Id: NodePropertyGrid.cs 453 2010-10-22 16:20:41Z cr333 $
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.ComponentModel;

namespace VideoLib.Utils
{
	/// <summary>
	/// Composite control that allows for editing of node properties, similar to Visual Studio's Properties tab.
	/// </summary>
	[Obsolete("Broken: cannot edit values.")]
	public class NodePropertyGrid : TableLayoutPanel
	{
		private ComboBox comboBox;
		private PropertyGrid propertyGrid;
		private ContextMenuStrip contextMenu;
		private ToolStripMenuItem resetItem;

		/// <summary>Initialises a new instance of the <see cref="NodePropertyGrid"/> class.</summary>
		public NodePropertyGrid() : base()
		{
			propertyGrid = new PropertyGrid();
			contextMenu = new ContextMenuStrip();
			resetItem = new ToolStripMenuItem();
			comboBox = new ComboBox();

			contextMenu.SuspendLayout();
			SuspendLayout();

			// 
			// comboBox
			// 
			comboBox.Dock = System.Windows.Forms.DockStyle.Fill;
			comboBox.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			comboBox.FormattingEnabled = true;
			comboBox.Location = new System.Drawing.Point(0, 0);
			comboBox.Margin = new System.Windows.Forms.Padding(0, 0, 0, 2);
			comboBox.MaxDropDownItems = 30;
			comboBox.Name = "comboBox";
			comboBox.Size = new System.Drawing.Size(Width, 21);
			comboBox.TabIndex = 0;

			// 
			// propertyGrid
			// 
			propertyGrid.ContextMenuStrip = contextMenu;
			propertyGrid.Dock = System.Windows.Forms.DockStyle.Fill;
			propertyGrid.Location = new System.Drawing.Point(0, 23);
			propertyGrid.Margin = new System.Windows.Forms.Padding(0);
			propertyGrid.Name = "propertyGrid";
			propertyGrid.Size = new System.Drawing.Size(Width, Height - 23);
			propertyGrid.TabIndex = 1;
			propertyGrid.ToolbarVisible = false;

			// 
			// contextMenu
			// 
			contextMenu.Items.AddRange(new System.Windows.Forms.ToolStripItem[] { resetItem });
			contextMenu.Name = "contextMenu";
			contextMenu.ShowImageMargin = false;
			contextMenu.Opening += new System.ComponentModel.CancelEventHandler(contextMenu_Opening);

			// 
			// resetItem
			// 
			resetItem.Name = "resetItem";
			resetItem.Text = "Reset";
			resetItem.Click += new System.EventHandler(resetValueMenuItem_Click);

			// 
			// NodePropertyGrid
			// 
			AutoSize = true;
			AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink;
			ColumnCount = 1;
			ColumnStyles.Add(new System.Windows.Forms.ColumnStyle());
			Controls.Add(propertyGrid, 0, 1);
			Controls.Add(comboBox, 0, 0);
			Dock = DockStyle.Fill;
			Location = new System.Drawing.Point(3, 16);
			RowCount = 2;
			RowStyles.Add(new System.Windows.Forms.RowStyle(SizeType.AutoSize));
			RowStyles.Add(new System.Windows.Forms.RowStyle(SizeType.AutoSize));
			Resize += new EventHandler(NodePropertyGrid_Resize);

			contextMenu.ResumeLayout(false);
			ResumeLayout(false);
			PerformLayout();
		}

		/// <summary>Sets the nodes to be editable.</summary>
		/// <param name="nodes">The nodes.</param>
		public void SetNodes(IEnumerable<INode> nodes)
		{
			// set up the settings PropertyGrid ---------------------------------------------------
			comboBox.SelectedIndexChanged += new EventHandler((sender, eventArgs) =>
					propertyGrid.SelectedObject = comboBox.SelectedItem);
			comboBox.DataSource = nodes.ToList();
			BeginInvoke(new Action(delegate()
			{
				comboBox.AutoCompleteSource = AutoCompleteSource.ListItems;
				comboBox.AutoCompleteMode = AutoCompleteMode.SuggestAppend;
				propertyGrid.SelectedObject = comboBox.SelectedItem;
			}));
		}

		private void NodePropertyGrid_Resize(object sender, EventArgs e)
		{
			comboBox.Width = Width;
			propertyGrid.Width = Width;
			propertyGrid.Height = Height - 23;
		}

		private void contextMenu_Opening(object sender, CancelEventArgs e)
		{
			// disable "Reset" item if not possible (also if already set to default value)
			resetItem.Enabled = propertyGrid.SelectedGridItem.PropertyDescriptor.CanResetValue(propertyGrid.SelectedObject);
		}

		private void resetValueMenuItem_Click(object sender, EventArgs e)
		{
			// reset value of selected property and refresh the grid
			propertyGrid.SelectedGridItem.PropertyDescriptor.ResetValue(propertyGrid.SelectedObject);
			propertyGrid.Refresh();
		}

	}
}
